import { Request, Response, NextFunction } from 'express';
import config from '../../../config/app.config';
import { EndpointResponse, EndpointResponseStatus } from '../models';
import messages from '../../../config/app.messages';
import { MiscHelpers } from '../helpers';
const axios = require('axios');

export const checkJWT = async (req: Request, res: Response, next: NextFunction) => {
    //
    // Initializing HTTP response object
    //
    let endpointResponse = new EndpointResponse();
    //
    // Getting input data from the query string
    //
    const lang = req.query['lang'] ? req.query['lang'] : 'es';
    const appMessages = messages[lang];
    //
    let httpCode = 401;
    const propertiesWithErrors = [];
    // console.log(req.headers);
    //
    // Get the jwt token from the headers
    //
    
    const token = req.headers['x-access-token'] as string;
    if (!token) {
        propertiesWithErrors.push({ property: 'none' , errors : [appMessages.gbl.token_not_received] });
        endpointResponse =
        MiscHelpers.setResponse(EndpointResponseStatus.ERR, httpCode, null, propertiesWithErrors, appMessages.gbl.token_not_received);
        return res.status(httpCode).send(endpointResponse);
    }
    //
    // Validate the token against the /employees API
    // Discovering employees service from the application config.
    // In (rootdir).env, the EXECENV param must be changed from
    // 'local' to 'awsdev' in order to fetch the correct api URL
    //   
    let apiAuthUrl = config.apis.EXECENV[process.env.EXECENV].auth.admin + "/verifytoken?lang="+lang;
    // console.log(apiAuthUrl)
    //
    // Calling the 'auth' API. The response is an object with the same structure
    // as EndpointResponse, so we send it directly to the client without calling
    // MisHelpers.setResponse
    //
    const axiosConfig = {
                method: 'get',
                url: apiAuthUrl,
                headers: { 'x-access-token': req.headers['x-access-token']}
    }  
    let axiosResponse = await axios(axiosConfig)
    .then(response => {
                 return response['data'];
    })
    .catch(error =>{
      let errMsg = 'AUTH ADMIN API : ';
      if (error['response']) {
        // If the error was generated by the AUTH ADMIN API controller or service, there is an EndpointResponse
        // object coming in the response, from which we can extract the error message. Otherwise, we take
        // the error from error['response']
        if (error['response']['data']) {
          errMsg = errMsg + error['response']['data']['message'];
        } else {
          errMsg = errMsg + error['response']['statusText'];
        }     
        httpCode = error['response']['status'];
        propertiesWithErrors.push({ property: 'none', errors: [errMsg]});
        return MiscHelpers.setResponse(EndpointResponseStatus.ERR, httpCode, null, propertiesWithErrors, errMsg);
      } else {
        httpCode = 500;
        errMsg = errMsg + error['code']
        propertiesWithErrors.push({ property: 'none', errors: [errMsg]});
        return MiscHelpers.setResponse(EndpointResponseStatus.FATAL, httpCode, null, propertiesWithErrors, errMsg);
      }
    });
    if (axiosResponse['code'] !== 200)  {
      res.status(axiosResponse['code']).send(axiosResponse);
      return;
    }
    
    res.locals.user = {
                          id: axiosResponse.data['id'],
                          role: axiosResponse.data['role'],
                          restaurant : axiosResponse.data['restaurant']
                      };
    //
    next();
};
